"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var chaingun_1 = require("@notabug/chaingun");
var GunLmdbClient_1 = require("./GunLmdbClient");
var NOOP = function () { };
var LmdbGraphConnector = /** @class */ (function (_super) {
    __extends(LmdbGraphConnector, _super);
    function LmdbGraphConnector(lmdbOpts) {
        if (lmdbOpts === void 0) { lmdbOpts = GunLmdbClient_1.DEFAULT_CONFIG; }
        var _this = _super.call(this, 'LmdbGraphConnector') || this;
        _this._client = new GunLmdbClient_1.GunLmdbClient(lmdbOpts);
        return _this;
    }
    LmdbGraphConnector.prototype.get = function (_a) {
        var _b;
        var soul = _a.soul, cb = _a.cb, _c = _a.msgId, msgId = _c === void 0 ? '' : _c, _d = _a.key // TODO
        , key = _d === void 0 ? '' : _d // TODO
        ;
        var node = this._client.get(soul);
        var put = node
            ? (_b = {},
                _b[soul] = node,
                _b) : null;
        var msg = { '#': chaingun_1.generateMessageId(), put: put };
        if (msgId)
            msg['@'] = msgId;
        if (cb)
            cb(msg);
        return NOOP;
    };
    LmdbGraphConnector.prototype.put = function (_a) {
        var graph = _a.graph, diffCb = _a.diffCb, _b = _a.msgId, msgId = _b === void 0 ? '' : _b, cb = _a.cb;
        var id = chaingun_1.generateMessageId();
        try {
            var diff = this._client.write(graph);
            if (cb) {
                cb({
                    '#': id,
                    '@': msgId,
                    ok: true,
                    err: null
                });
            }
            if (diff && diffCb) {
                diffCb({
                    '#': msgId,
                    put: diff
                });
            }
        }
        catch (err) {
            console.warn(err.stack);
            if (cb) {
                cb({
                    '#': id,
                    '@': msgId,
                    ok: false,
                    err: err
                });
            }
            else {
                console.warn(err.stack || err);
            }
        }
        return NOOP;
    };
    return LmdbGraphConnector;
}(chaingun_1.GunGraphWireConnector));
exports.LmdbGraphConnector = LmdbGraphConnector;
//# sourceMappingURL=LmdbGraphConnector.js.map